// LuaConsoleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "lua.h"
#include "LuaConsole.h"
#include "LuaConsoleDlg.h"
#include "PromptBox.h"

extern void lua_baselibopen (lua_State *L);
extern void lua_iolibopen (lua_State *L);
extern void lua_strlibopen (lua_State *L);
extern void lua_mathlibopen (lua_State *L);
extern void lua_dblibopen (lua_State *L);

BOOL bIsLua;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

lua_State * lua;
// BOOL bIsLua;

CLuaConsoleDlg *pThis;

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CLuaConsoleDlg dialog

CLuaConsoleDlg::CLuaConsoleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLuaConsoleDlg::IDD, pParent)
	, inbuffer(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLuaConsoleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_INPUT, inbuffer);
	DDX_Control(pDX, IDC_INPUT, LuaEditInput);
	DDX_Control(pDX, IDC_OUTPUT, ConsoleOutput);
}

BEGIN_MESSAGE_MAP(CLuaConsoleDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_EVAL, OnBnClickedEval)
	ON_EN_CHANGE(IDC_OUTPUT, OnEnChangeOutput)
END_MESSAGE_MAP()


// CLuaConsoleDlg message handlers

BOOL CLuaConsoleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	pThis=this;

	lua=lua_open(4096);
    lua_baselibopen(lua);
    lua_strlibopen(lua);
    lua_mathlibopen(lua);
    lua_iolibopen(lua);
	bIsLua=FALSE;
	lua_setlinehook(lua,line_hook);
	
	// add lua error callback
    lua_register(lua,"_ALERT",lua_ERROR);
    // register lua extensions
    lua_register(lua,"print",lua_Print);
    lua_register(lua,"promptbox",lua_promptbox);
    lua_register(lua,"atanh",lua_atanh);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CLuaConsoleDlg::ToOutput(CString str)
{
//	UpdateData(TRUE);
//	outbuffer+=str;
//	UpdateData(FALSE);

	int Length = ConsoleOutput.GetWindowTextLength();

	ConsoleOutput.SetSel(Length, Length);
	ConsoleOutput.ReplaceSel(str);
	ConsoleOutput.LineScroll( ConsoleOutput.GetLineCount() );
}

int CLuaConsoleDlg::lua_promptbox(lua_State *L)
{
	CPromptBox dlg;

	int n=lua_gettop(L);
	if(n>0) dlg.mytitle = lua_tostring(L,1);
	dlg.DoModal();
	lua_pushstring(L,dlg.instring);

	return TRUE;
}

int CLuaConsoleDlg::lua_Print(lua_State *L)
{
	// Snatched this from the Lua source code,
	// replacing writes to stdout with my custom
	// output to the LuaConsole's edit box
	int n = lua_gettop(L);				// number of arguments
	int i;
	lua_getglobal(L, "tostring");
	for (i=1; i<=n; i++) {
		CString s;
		lua_pushvalue(L, -1);			// function to be called 
		lua_pushvalue(L, i);			// value to print 
		lua_rawcall(L, 1, 1);
		s = lua_tostring(L, -1);		// get result 
		if (i>1) pThis->ToOutput("\t");
		else pThis->ToOutput("--> ");
		pThis->ToOutput(s);
		lua_pop(L, 1);					// pop result
	}
	pThis->ToOutput("\r\n");
 
	return 0;
} 

int CLuaConsoleDlg::lua_ERROR(lua_State *L)
{

    CString errmsg;
    errmsg.Format("%s",lua_tostring(L,1));

    // Somthing went wrong in lua execution
    // Windows dosn't have stdout so lets afxmessagebox it
	pThis->ToOutput(errmsg+"\r\n");
    AfxMessageBox(errmsg);

    return 0;
}

void CLuaConsoleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLuaConsoleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLuaConsoleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CLuaConsoleDlg::OnBnClickedOk()
{
	lua_close(lua);

	OnOK();
}

void CLuaConsoleDlg::OnBnClickedEval()
{
	CString LuaCmd;

	UpdateData();
	ToOutput(inbuffer+"\r\n");
	LuaCmd=inbuffer;
	inbuffer="";
	UpdateData(FALSE);
	bIsLua=TRUE;
	if(lua_dostring(lua,LuaCmd)!=FALSE){
		inbuffer=LuaCmd;
		UpdateData(FALSE);
	}
	bIsLua=FALSE;
}

void CLuaConsoleDlg::OnEnChangeOutput()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
}

void CLuaConsoleDlg::line_hook(lua_State *L, lua_Debug *ar)
{

	BOOL bIllegal=FALSE;
    MSG msg;

	while ( ::PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) 
	{ 
		if ((msg.message == WM_KEYDOWN) && (msg.wParam == VK_PAUSE))
		{
			bIsLua=FALSE;
			MessageBeep(MB_ICONEXCLAMATION);
			lua_error(L,NULL);
		}
		if(msg.message==WM_KEYDOWN) bIllegal=TRUE;

		// should these be blocked?
//		if(msg.message==WM_LBUTTONDOWN) bIllegal=TRUE;
//		if(msg.message==WM_RBUTTONDOWN) bIllegal=TRUE;
//		if(msg.message==WM_LBUTTONUP) bIllegal=TRUE;
		if(msg.message==WM_LBUTTONDBLCLK) bIllegal=TRUE;
		if(msg.message==WM_RBUTTONDBLCLK) bIllegal=TRUE;

		// side-track all commands
		if(msg.message==WM_COMMAND)
		{
			UINT wID=LOWORD(msg.wParam);  
			if(wID==ID_FILE_OPEN) bIllegal=TRUE;
			if(wID==ID_FILE_NEW) bIllegal=TRUE;
			if(wID==ID_FILE_SAVE) bIllegal=TRUE;
			if(wID==ID_FILE_SAVE_AS) bIllegal=TRUE;
			if(wID==ID_APP_EXIT) bIllegal=TRUE;
		}
		
		if (bIllegal==FALSE) DispatchMessage(&msg);
	}

}

int CLuaConsoleDlg::lua_atanh(lua_State *L)
{
	CComplex x;

	x=lua_tonumber(L,1);

	lua_pushnumber(L,(I*(arg(1+x)-arg(1-x))+log(abs(1+x)/abs(1-x)))/2);

	return 1;
}

